

module.exports = function(babel, opts) {

  var config = {
    presets: [
      [
        require('@babel/preset-env'),
        Object.assign({
          targets: { "browsers": "last 2 versions, safari >= 7" },
          useBuiltIns: 'entry'
        }, opts)
      ],
      require('@babel/preset-flow'),
      require('@babel/preset-react')
    ],
    plugins: [
      //styled-components
      [require('babel-plugin-styled-components'), { displayName: false }],

      //decorators
      [require('@babel/plugin-proposal-decorators'), {legacy: true}],
      [require('@babel/plugin-proposal-class-properties'), {loose: true}],

      //object-assign
      require('@babel/plugin-transform-object-assign'),

      //stage0
      require('@babel/plugin-proposal-function-bind'),

      // Stage 1
      require('@babel/plugin-proposal-export-default-from'),
      require('@babel/plugin-proposal-logical-assignment-operators'),
      [require('@babel/plugin-proposal-optional-chaining'), { "loose": false }],
      [require('@babel/plugin-proposal-pipeline-operator'), { "proposal": "minimal" }],
      [require('@babel/plugin-proposal-nullish-coalescing-operator'), { "loose": false }],
      require('@babel/plugin-proposal-do-expressions'),

      // Stage 2
      require('@babel/plugin-proposal-function-sent'),
      require('@babel/plugin-proposal-export-namespace-from'),
      require('@babel/plugin-proposal-numeric-separator'),
      require('@babel/plugin-proposal-throw-expressions'),

      // Stage 3
      require('@babel/plugin-syntax-dynamic-import'),
      require('@babel/plugin-syntax-import-meta'),
      require('@babel/plugin-proposal-json-strings')
    ]
  };

  if(process.env.NODE_ENV ==='production'){
    //runtime
    config.plugins.push(
      require('@babel/plugin-transform-runtime')
    )
  }

  return config.
}
